/* C_OCCAM.c	Version 1.0
 *
 * Copyright (C)  1990
 *
 * Created: 	1/15/1990
 *
 * Author:	CH
 *
 */

/*
#include "/usr/etc/transp/link.h"
*/
#include "/usr/mtool/server/sun/link.h"
#include <stdio.h>
#include <string.h>
#include <sys/file.h>

#define	LOCK		"/usr/megatool_vm/USER"
#define	LOCK_MES	"Diekmann/Simon special server\n"


int	SendInt( LinkId, timeout, p_int )
int	LinkId;
int	timeout;
int	*p_int;
{
	char	tpint[4];
	char	*p = (char *)p_int;
	int	i;

	for (i=3; i>=0; i--)
		tpint[i] = *(p++);
	if ( WriteLink( LinkId, tpint, 4, timeout) == 4 )
		return 0;
	else
		return -1;
}

int	SendReal( LinkId, timeout, p_real )
int	LinkId;
int	timeout;
float	*p_real;
{
	char	tpreal[4];
	char	*p = (char *)p_real;
	int	i;

	for (i=3; i>=0; i--)
		tpreal[i] = *(p++);
	if ( WriteLink( LinkId, tpreal, 4, timeout) == 4 )
		return 0;
	else
		return -1;
}

int	ReceiveInt( LinkId, timeout, p_int )
int	LinkId;
int	timeout;
int	*p_int;
{
	char	tpint[4];
	char	*p = (char *)p_int;
	int	i;

	if ( ReadLink( LinkId, tpint, 4, timeout ) == 4 )
	{
		for (i=3; i>=0; i--)
			*(p++) = tpint[i];
		return 0;
	}
	else
		return -1;
}

int	ReceiveReal( LinkId, timeout, p_real )
int	LinkId;
int	timeout;
float	*p_real;
{
	char	tpreal[4];
	char	*p= (char *)p_real;
	int	i;

	if ( ReadLink( LinkId, tpreal, 4, timeout ) == 4 ) {
		for (i=3; i>=0; i--)
			*(p++) = tpreal[i];
		return 0;
	}
	else
		return -1;
}

int	SendProt( LinkId, timeout, val_prot )
int	LinkId;
int	timeout;
char	val_prot;
{
	if ( WriteLink( LinkId, &val_prot, 1, timeout ) == 1 )
		return 0;
	else
		return -1;
}

int	ReceiveProt( LinkId, timeout, p_prot )
int	LinkId;
int	timeout;
char	*p_prot;
{
	if ( ReadLink( LinkId, p_prot, 1, timeout ) == 1 )
		return 0;
	else
		return -1;
}

#define	BUFFERSIZE	512

static	char	buf[BUFFERSIZE];

int	LoadProgram( LinkId, timeout, fn )
int	LinkId;
int	timeout;
char	*fn;
{
	FILE	*f;
	int	x;

	ResetLink( LinkId );
	f = fopen(fn, "rb");
	if (f == NULL)
		return -1;
	do
	{
		x = fread(buf, 1, BUFFERSIZE, f);
		if (x > 0)
		{
			if ( WriteLink(LinkId, buf, x, timeout) != x )
				return -2;
		}
	}
	while (x == BUFFERSIZE);
	fclose(f);
	return 0;
}


int	LinkAlloc( LinkId , ErrMsg, lockFileFlag )
int	LinkId;
char	*ErrMsg;
int	lockFileFlag;			/* TRUE => use lock file */
/* return: link identifier */
{
	int	lerr;
	char	link_name[100];

	sprintf( link_name, "%d", LinkId);
	if ( lockFileFlag ) {
		char	lock_fn[100];

		sprintf( lock_fn, "%s%d", LOCK, LinkId );

		if (! access(lock_fn, 0) ) {
			FILE	*f;
			char	user_name[250];

			lerr = ENOTAVAIL;
			f = fopen ( lock_fn, "r" );
			fscanf( f, "%[^\n]s", user_name );
			fclose( f );
			sprintf( ErrMsg, "'%s'\nused by %s", lerror( lerr ), user_name );
		} else {
			lerr = OpenLink ( link_name );

			if (lerr >= 0) {
				char	command[100];

				sprintf( command, "who am i > %s%d", LOCK, LinkId );
				system ( command );
			}
			sprintf( ErrMsg, "'%s'", lerror( lerr ) );
		}
	} else {
		lerr = OpenLink ( link_name );
		sprintf( ErrMsg, "'%s'", lerror( lerr ) );
	}

	return lerr;			/* return: >= 0 link id		*/
					/*	    < 0 error number	*/
}

int	LinkFree( link_id, lockFileFlag )
int	link_id;
int	lockFileFlag;
{
	if ( lockFileFlag ) {
		char    command[100];

		sprintf(command, "rm %s%d", LOCK, link_id);
		CloseLink(link_id);
		system(command);
	} else {
		CloseLink(link_id);
	}
	return 0;
}

