#include "haeufig.h"

void	Init_Struktur( HaeufigkeitRec *h )
{
	h->werte_anzahl = 0;
	h->hilfssumme = 0.0;
	h->mittelwert = 0.0;
}

void	Neuer_Wert( HaeufigkeitRec *h, double x )
{
	(h->werte_anzahl)++;
	if ( h->werte_anzahl == 1 ) {
	/* Erster Wert wird in die Haufigkeitsverteilung aufgenommen. */
		h->maximum = h->minimum = x;
	} else {
	/* Ein weiterer Wert wird in die Haeufigkeitsverteilung aufgenommen. */
		if ( x < h->minimum )
			h->minimum = x;
		if ( x > h->maximum )
			h->maximum = x;
	}
	/* Berechne neuen Mittelwert und Standardabweichung. */
	h->hilfssumme = h->hilfssumme - h->hilfssumme/h->werte_anzahl + x*x/h->werte_anzahl;
	h->mittelwert = h->mittelwert - h->mittelwert/h->werte_anzahl + x/h->werte_anzahl;
	h->standardabweichung = h->hilfssumme - h->mittelwert*h->mittelwert;
}

double	Sigma( HaeufigkeitRec *h )
{
	return sqrt( h->standardabweichung );
}

double	Mittelwert( HaeufigkeitRec *h )
{
	return h->mittelwert;
}

double	Minimum( HaeufigkeitRec *h )
{
	return h->minimum;
}

double	Maximum( HaeufigkeitRec *h )
{
	return h->maximum;
}

