/*************************************************************************

		DiagramP.h, v 1.0  90/2/9  11:04:43   author CH

**************************************************************************/

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _DiagramP_h
#define _DiagramP_h

#include "Diagram.h"
#include <X11/CoreP.h>

/* New fields for the diagram widget instance record */
typedef	struct {
	Cursor	cursor;		/* cursor */
	Pixel	fgpixel;	/* color index for graph */
	Pixel	hipixel;	/* color index for text */
	XFontStruct	*font;	/* font for text */
	GC	fgGC;		/* graphics context for fgpixel */
	GC	hiGC;		/* graphics context for hipixel */
	GC	clGC;		/* graphics context for clear pixel */
/* start of graph stuff */
	char	*text;		/* Label des Windows */
	int	n;		/* Anzahl der Zahlenwerte */
	float	value[1024];	/* Zahlenwerte */
	char	valstr[30];	/* String des n-ten Zahlenwertes */
	int	x_val;		/* X-Position des Zahlenwertstrings */
	int	y_val;		/* Y-Position des Zahlenwertstrings */
	int	x_n;		/* X-Position der Diagramlinie des n-ten Wertes */
	int	y_offset;	/* oberer Rand */
	int	scale;		/* Scalierungsfaktor */
	float	max_value;	/* Maximum der werte */
	} DiagramPart;

/* Full instance record declaration */
typedef	struct _DiagramRec {
	CorePart	core;
	DiagramPart	diagram;
	} DiagramRec;

/* New fields for the Diagram widget class record */
typedef struct {int dummy;} DiagramClassPart;

/* Full class record declaration. */
typedef	struct	_DiagramClassRec {
	CoreClassPart		core_class;
	DiagramClassPart	diagram_class;
	} DiagramClassRec;

/* Class pointer. */
extern DiagramClassRec diagramClassRec;

#endif _DiagramP_h
