/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XtTimer_h
#define _XtTimer_h

/***********************************************************************
 *
 * Timer Widget
 *
 ***********************************************************************/

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		white
 backingStore	     BackingStore	BackingStore	default
 border		     BorderColor	Pixel		Black
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 font		     Font		XFontStruct*	fixed
 foreground	     Foreground		Pixel		black
 height		     Height		Dimension	164
 highlight	     Foreground		Pixel		black
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 padding	     Margin		int		8
 reverseVideo	     ReverseVideo	Boolean		False
 update		     Interval		int		5 (seconds)
 width		     Width		Dimension	164
 x		     Position		Position	0
 y		     Position		Position	0

*/


#include <X11/Xmu/Xmu.h>

/* Resource names used to the timer widget */

#define XtNupdate		"update"
		/* Int: how often to update hands? */
#define XtNhighlight		"highlight"
		/* color of hand outline */
#define XtNbackingStore		"backingStore"
		/* when server should use backing store */
#define XtNpadding		"padding"
		/* Int: amount of space around outside of timer */

typedef struct _TimerRec *TimerWidget;  /* completely defined in TimerPrivate.h */
typedef struct _TimerClassRec *TimerWidgetClass;    /* completely defined in TimerPrivate.h */

extern WidgetClass timerWidgetClass;

extern	void	XtSetStartTimer( TimerWidget	w );

extern	long	XtGetTimer( TimerWidget w );

extern	long	XtSetStopTimer( TimerWidget	w );

#endif _XtTimer_h
/* DON'T ADD STUFF AFTER THIS #endif */
