/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/


#ifndef _XtTimerP_h
#define _XtTimerP_h

#include "Timer.h"
#include <X11/CoreP.h>

#define	ASCII_TIME_BUFLEN	32

/* New fields for the timer widget instance record */
typedef struct {
	 Pixel	fgpixel;	/* color index for text */
	 Pixel	Hipixel;	/* color index for Highlighting */
	 XFontStruct	*font;	/* font for text */
	 GC	myGC;		/* pointer to GraphicsContext */
	 GC	EraseGC;	/* eraser GC */
	 GC	HighGC;		/* Highlighting GC */
/* start of graph stuff */
	 int	update;		/* update frequence */
	 int	backing_store;	/* backing store type */
	 Boolean reverse_video;
	 Boolean beeped;
	 int	padding;
	 struct tm	otm ;
	 XtIntervalId	interval_id;
	 char	prev_time_string[ASCII_TIME_BUFLEN];
	 long	start_time;	/* start time */
	 Boolean running;	/* timer is running */
   } TimerPart;

/* Full instance record declaration */
typedef struct _TimerRec {
   CorePart core;
   TimerPart timer;
   } TimerRec;

/* New fields for the Timer widget class record */
typedef struct {int dummy;} TimerClassPart;

/* Full class record declaration. */
typedef struct _TimerClassRec {
   CoreClassPart core_class;
   TimerClassPart timer_class;
   } TimerClassRec;

/* Class pointer. */
extern TimerClassRec timerClassRec;

#endif _XtTimerP_h
