/*************************************************************************

		Tsp.h, v 1.10  90/2/7  15:34:43   author CH

**************************************************************************/

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XtTsp_h
#define _XtTsp_h

/***********************************************************************
 *
 * Tsp Widget
 *
 ***********************************************************************/

/* Parameters:

 Name			Class			RepType		Default Value
 ----			-----			-------		-------------
 background		Background		Pixel		White
 border			BorderColor		Pixel		Black
 borderWidth		BorderWidth		Dimension	1
 destroyCallback	Callback		Pointer		NULL
 font			Font			XFontStruct*	XtDefaultFont
 foreground		Foreground		Pixel		Black
 height			Height			Dimension	300
 mappedWhenManaged	MappedWhenManaged	Boolean		True
 reverseVideo		ReverseVideo		Boolean		False
 width			Width			Dimension	300
 x			Position		Position	0
 y			Position		Position	0

*/


#define	XtNforeground		"foreground"
#define	XtNtowncolor		"towncolor"
#define	XtCTowncolor		"Towncolor"
#define	XtNtournewcolor		"tournewcolor"
#define	XtCTournewcolor		"Tournewcolor"
#define	XtNtouroldcolor		"touroldcolor"
#define	XtCTouroldcolor		"Touroldcolor"

typedef struct _TspRec *TspWidget;  /* completely defined in TspPrivate.h */
typedef struct _TspClassRec *TspWidgetClass;    /* completely defined in TspPrivate.h */

extern WidgetClass tspWidgetClass;

extern	int	XtSetTownPositions( TspWidget w, int n, float *x, float *y );

extern  int     XtSetTour( TspWidget w, int *tour );

extern	void	XtCalculatePos( TspWidget w );

extern	void	XtDrawTowns( TspWidget w );

extern void	XtDrawTour( TspWidget w );

extern	void	XtClean( TspWidget w );

extern	void	XtDraw( TspWidget w, int *tour );

#endif	_XtTsp_h

/* DON'T ADD STUFF AFTER THIS #endif */
