/*************************************************************************

		TspP.h, v 1.10  90/2/7  15:34:43   author CH

**************************************************************************/

/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _TspP_h
#define _TspP_h

#include "Tsp.h"
#include <X11/CoreP.h>

/* maximal number of towns */

#define	MAX_N	1024

/* record for the neighbor of a town */
typedef	struct {
	int	t1;
	int	t2;
} Neighbor;

/* New fields for the tsp widget instance record */
typedef struct {
	int		pseudoColor;		/* videoboard with pseudocolor */
	Cursor		cursor;			/* cursor */
	Pixel		fgpixel;		/* color index for foreground */
	XFontStruct	*font;			/* font for text */
	GC		clGC;			/* graphics context for clear pixel */
	GC		townGC;			/* graphic context for town pixel */
	GC		new_tour_GC;		/* graphic context for new tour pixel */
	GC		old_tour_GC;		/* graphic context for old tour pixel */
	Boolean		reverseVideo;		/* reverse video flag */
/* start of graph stuff */
	int		n;			/* number of towns */
	float		xcoord[MAX_N];		/* xcoordinates of towns */
	float		ycoord[MAX_N];		/* ycoordinates of towns */
	float		xmin;			/* min. of xcoordinates */
	float		xmax;			/* max. of xcoordinates */
	float		ymin;			/* min. of ycoordinates */
	float		ymax;			/* max. of ycoordinates */
	int		xpos[MAX_N];		/* xcoordnates of towns in window */
	int		ypos[MAX_N];		/* xcoordnates of towns in window */
	int		tour_stored;		/* at least one tour is stored */
	int		old_tour_stored;	/* more than one tour is stored */
	Neighbor	*tour;			/* description of the tour */
	Neighbor	*old_tour;		/* description of the old tour */
	Neighbor	*tour_buf;		/* tour buffer */
	} TspPart;

/* Full instance record declaration */
typedef	struct	_TspRec {
		CorePart core;
		TspPart tsp;
	} TspRec;

/* New fields for the Tsp widget class record */
typedef struct {int dummy;} TspClassPart;

/* Full class record declaration. */
typedef struct _TspClassRec {
		CoreClassPart core_class;
		TspClassPart tsp_class;
	} TspClassRec;

/* Class pointer. */
extern	TspClassRec	tspClassRec;

#endif _TspP_h
