#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Paned.h>
#include "xserver.h"
#include "../../c_occam.h"

#include "xserver.bit"

#ifdef UNIX
#define	MAXLINKS	10			/* maximale Anzahl von TP */
#endif
#ifdef HELIOS
#define	MAXLINKS	4			/* Anzahl von Tp Links */
#endif

/*-------------------------------------------------------------------------------*/

Widget	toplevel;

/*-------------------------------------------------------------------------------*/
/* Typedefinitionen: */

typedef	struct	{
		Widget	pop;
		Widget	dialog;
		Widget	button;
		char	*str;
		}
	OkData;

typedef	struct	{
		Widget	pop;
		Widget	button;
		}
	CancelData;

/*-------------------------------------------------------------------------------*/

void	Skip()
{
}

extern	void	LinkDownCallback();
extern	void	LinkUpCallback();

static	String	linkTranslations =
	"<Btn2Down>:Skip()\n\
	 <Btn2Up>  :LinkDownCallback()\n\
	 <Btn1Down>:Skip()\n\
	 <Btn1Up>  :LinkUpCallback()";

XtActionsRec	actionTable[] = {
	{"Skip",		Skip},
	{"LinkDownCallback",	LinkDownCallback},
	{"LinkUpCallback",	LinkUpCallback}
};

#define	actionTable_num		3

/*-------------------------------------------------------------------------------*/

#define	LINKBUTTONLABEL		" TRANSPUTER %d "
#define	CONNECTBUTTONLABEL	" TRANSPUTER  BESETZEN "
#define	DISCONNECTBUTTONLABEL	" TRANSPUTER FREIGEBEN "
#define RESETBUTTONLABEL	" RESET TRANSPUTER "
#define DEBUGBUTTONLABEL	" DEBUG TRANSPUTER "
#define	PROGOBUTTONLABEL	" OCCAM-PROGRAMM "
#define	LADEBUTTONLABEL		" LADE PROGRAMM "
#define	PROGCBUTTONLABEL	" C-PROGRAMM "
#define	STARTBUTTONLABEL	" STARTE PROGRAMM "
#define	HELPBUTTONLABEL		" HELP "
#define ENDEBUTTONLABEL		" ENDE "

/*---------------------------------------------------------------------------------------*/

int	LinkId = 0;				/* Default LinkId */
char	DebugName[100] = "debug.run";		/* Default OCCAM-debug program */
char	ProgName[100] = "occam.bin";		/* Default OCCAM-program filename */
char	CName[100] = "chost";			/* Default C-host filename */
char	Farbe[20] = "";				/* Farbe */
char	Connect = FALSE;			/* Default kein Transputer */
char	C_running = FALSE;			/* Default kein C-Host laeuft */

Widget	connectcommand;				/* Kommandobutton Connect */
Widget	linkcommand;				/* Kommandobutton Link */
Widget	resetcommand;				/* Kommandobutton Reset Link */
Widget	loadcommand;				/* Kommandibutton Lade OCCAM-Programm */
Widget	startcommand;				/* Kommandobutton Starte C-Host */
Widget	exitcommand;				/* Kommandobutton beende Xserver */
Widget	progocommand;				/* Kommandobutton frage OCCAM-Filename */
Widget	progccommand;				/* Kommandobutton frage C-Filename */

/*---------------------------------------------------------------------------------------*/

void	OkCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	OkData	*data = (OkData *)client_data;
	int	n;
	Arg	arg[10];

	strcpy( data->str, XawDialogGetValueString( data->dialog ) );
	n = 0;
	XtSetArg( arg[n], XtNsensitive, TRUE ); n++;
	XtSetValues( data->button, arg, n);		/* Kommandobutton des Popupwidget wieder sensitive */

	XtPopdown( data->pop );
}

void	CancelCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int	n;
	Arg	arg[3];
	CancelData	*data = (CancelData *)client_data;
	n = 0;
	XtSetArg( arg[n], XtNsensitive, TRUE ); n++;
	XtSetValues( data->button, arg, n);

	XtPopdown( data->pop );
}

void	ReturnCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	XtPopdown( (Widget)client_data );
}

/*-------------------------------------------------------------------------------*/
/* Popup fuer Occamfilename */

Widget  popoccamfile;

void	PopOccamfile()
{
static	OkData		okdata;
static	CancelData	canceldata;	
	int	n;
	Arg	arg[10];
	Widget	dialog, ok, cancel;

	n = 0;
	popoccamfile = XtCreatePopupShell( "Occamfilename", topLevelShellWidgetClass, toplevel, arg, n );

	n = 0;
	XtSetArg( arg[n], XtNlabel, (XtArgVal)"file name:" );	n++;
	XtSetArg( arg[n], XtNvalue, ProgName );			n++;
	dialog = XtCreateManagedWidget( "dialogo", dialogWidgetClass, popoccamfile, arg, n );
	
	okdata.pop	= popoccamfile;		/* Popup shell */
	okdata.dialog	= dialog;		/* Dialogwidget fuer Wertrueckgabe */
	okdata.button	= progocommand;		/* Kommandowidget des Aufrufers */
	okdata.str	= ProgName;		/* Rueckgabe aus der Dialogbox */
	n = 0;
	ok = XtCreateManagedWidget( "OK!", commandWidgetClass, dialog, arg, n);
	XtAddCallback( ok, XtNcallback, OkCallback, (caddr_t)(&okdata) );

	canceldata.pop		= popoccamfile;
	canceldata.button	= progocommand;
	n = 0;
	cancel = XtCreateManagedWidget( "CANCEL", commandWidgetClass, dialog, arg, n);
	XtAddCallback( cancel, XtNcallback, CancelCallback, (caddr_t)(&canceldata) );
}

/*---------------------------------------------------------------*/
/* Popup fuer C-Filenamen */

Widget	popcfile;

void	PopCfile()
{
static	OkData		okdata;
static	CancelData	canceldata;
	int	n;
	Arg	arg[10];
	Widget	dialog, ok, cancel;

	n = 0;
	popcfile = XtCreatePopupShell( "Hostfilename", topLevelShellWidgetClass, toplevel, arg ,n );

	n = 0;
	XtSetArg( arg[n], XtNlabel, (XtArgVal)"file name:" );	n++;
	XtSetArg( arg[n], XtNvalue, CName );			n++;
	dialog = XtCreateManagedWidget( "dialogc", dialogWidgetClass, popcfile, arg, n );

	okdata.pop	= popcfile;			/* Popupwidget */
	okdata.dialog	= dialog;			/* Dialogbox */
	okdata.button	= progccommand;			/* Kommandowidget */
	okdata.str	= CName;			/* Rueckgabe aus der Dialogbox */
	n = 0;
	ok = XtCreateManagedWidget( "OK!", commandWidgetClass, dialog, arg, n );
	XtAddCallback( ok, XtNcallback, OkCallback, (caddr_t)(&okdata) );

	canceldata.pop	= popcfile;
	canceldata.button = progccommand;
	n = 0;
	cancel = XtCreateManagedWidget( "CANCEL", commandWidgetClass, dialog, arg, n );
	XtAddCallback( cancel, XtNcallback, CancelCallback, (caddr_t)(&canceldata) );
}

/*---------------------------------------------------------------------------------------------*/

#define	textBufferSize	10000

typedef	struct {
	Widget	shell;
	Widget	title;
	Widget	text;
	Widget	button;			/* call button */
	char	*buffer;
	int	bufSize;
	int	mode;
} EditorWinRec, *EditorWin;

void	ExitEditorWin( w, client_data, call_data )
Widget	w;
caddr_t	client_data;
caddr_t	call_data;
{
	EditorWin	editor = (EditorWin)client_data;

	XtPopdown( editor->shell );
	if ( editor->button )
		XtSetSensitive( editor->button, True );		/* enable push button */
}

EditorWin CreateEditorWin( name, editorTitle, width, height, mode )
char*	name;
char	*editorTitle;
int	width;
int	height;
int	mode;
{
	EditorWin	editor = (EditorWin)XtCalloc( 1, sizeof(EditorWinRec) );
	Arg		args[7];
	int		n;
	Widget		frame, title, text, controls, done;

	n = 0;
	editor->shell = XtCreatePopupShell( name, topLevelShellWidgetClass, toplevel, NULL, n );
	n = 0;
	frame = XtCreateWidget( "editorFrame", panedWidgetClass, editor->shell, args, n );

	/* create title */
	n = 0;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	XtSetArg( args[n], XtNlabel, editorTitle );	n++;
	title =  XtCreateManagedWidget( "editorTitle", labelWidgetClass, frame, args, n );
	editor->title = title;

	editor->buffer = XtCalloc( textBufferSize, sizeof(char) );
	editor->bufSize = textBufferSize;
	editor->mode = mode;

	/* create text */
	n = 0;
	XtSetArg( args[n], XtNstring, editor->buffer );	n++;
	XtSetArg( args[n], XtNeditType, editor->mode );	n++;
	XtSetArg( args[n], XtNlength, editor->bufSize );	n++;
	XtSetArg( args[n], XtNwidth, width );	n++;
	XtSetArg( args[n], XtNheight, height );	n++;
	text = XtCreateManagedWidget( "text", asciiTextWidgetClass, frame, args, n );
	editor->text = text;

	/* create controls */
	n = 0;
	XtSetArg( args[n], XtNfromVert, text );		n++;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	controls = XtCreateManagedWidget( "editorControls", boxWidgetClass, frame, args, n );

	/* create button */
	n = 0;
	XtSetArg( args[n], XtNlabel, "done" );	n++;
	done = XtCreateManagedWidget( "doneButton", commandWidgetClass, controls, args, n );
	XtAddCallback( done, XtNcallback, ExitEditorWin, (caddr_t)editor );

	XtManageChild( frame );
	XtRealizeWidget( editor->shell );

	return editor;
}

void	StartEditorWin( editor )
EditorWin	editor;
{
	if ( editor->button )
		XtSetSensitive( editor->button, False );		/* disable push button */
	XtPopup( editor->shell, XtGrabExclusive );
}

void	ChangeTextSource( editor, str )
EditorWin	editor;
char		*str;
{
	Arg	args[3];
	int	n;
/*
	Widget	old = XawTextGetSource( editor->text );
*/

	n = 0;
	XtSetArg( args[n], XtNstring, str );		n++;
	XtSetArg( args[n], XtNlength, editor->bufSize );	n++;
	XtSetArg( args[n], XtNeditType, editor->mode );	n++;
	XawTextSetSource( editor->text,
			XawStringSourceCreate( editor->text, args, n ), (XawTextPosition)0 );
/*
	XawStringSourceDestroy( old );
*/
}

/*---------------------------------------------------------------------------------*/
/* Error window functions */

void	Error( str )
char	*str;			/* error message */
{
static	EditorWin	error = NULL;
	char		*iconName = "xserver: error";
	Arg		args[1];
	int		n;

	if ( !error ) {
		error = CreateEditorWin( "errorWindow", "error Window", 400, 200, XawtextRead );
		error->button = NULL;		/* no call button */
	}

	ChangeTextSource( error, str );
	n = 0;
	XtSetArg( args[n], XtNiconName, iconName );	n++;
	XtSetValues( error->shell, args, n );

	StartEditorWin( error );
}

/*---------------------------------------------------------------------------------------------*/
/* Debug window function */

void	Debug( str )
char	*str;
{
static	EditorWin	debug = NULL;
	char		*iconName = "xserver: debug";
	Arg		args[1];
	int		n;

	if ( !debug ) {
		debug = CreateEditorWin( "debugWindow", "debug Window", 500, 200, XawtextRead );
		debug->button = NULL;			/* no call button */
	}

	ChangeTextSource( debug, str );
	n = 0;
	XtSetArg( args[n], XtNiconName, iconName );	n++;
	XtSetValues( debug->shell, args, n );

	StartEditorWin( debug );
}
#if 0
/*---------------------------------------------------------------------------------------------*/
/* Help functions */

char	*helpText =	"\n"\
			"The full text of help is not available, because the help file\n"\
			"couldn't be opened.\n"\
			"\n"\
			"xserver is a simple interactive transputer server program.\n"\
			"It is build on the X-Toolkit and the Athena Widgets.\n"\
			"\n"\
			"You can start the program as: xserver [ .. ]\n"\
			"\n"\
			"CREDITS:\n"\
			"	Version 1.1 beta\n"\
			"	Author: Ralf Diekmann, Jens C.H. Simon\n"\
			"\n";

typedef	struct {
	Widget	shell;
	Widget	title;
	Widget	text;
	Widget	button;		/* help call-button */
	char	*buffer;
	int	bufSize;
	int	mode;
} HelpWinRec, *HelpWin;

void	ExitHelpWin( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	HelpWin	help = (HelpWin)client_data;

	XtPopdown( help->shell );
	XtSetSensitive( help->button, True );		/* enable push help button */
}

HelpWin	CreateHelpWin( name, mode )
char	*name;
int	mode;
{
	HelpWin	help = (HelpWin)XtCalloc( 1, sizeof(HelpWinRec) );
	Arg	args[7];
	int	n;
	Widget	frame, title, text, controls, done;

	n = 0;
	help->shell = XtCreatePopupShell( name, topLevelShellWidgetClass, toplevel, NULL, n );
	n = 0;
	frame = XtCreateWidget( "helpFrame", panedWidgetClass, help->shell, args, n );

	/* create title */
	n = 0;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	XtSetArg( args[n], XtNlabel, "help window" );	n++;
	title =  XtCreateManagedWidget( "helpTitle", labelWidgetClass, frame, args, n );
	help->title = title;

	help->buffer = XtCalloc( textBufferSize, sizeof(char) );
	help->bufSize = textBufferSize;
	help->mode = XawtextRead;

	/* create text */
	n = 0;
	XtSetArg( args[n], XtNstring, help->buffer );	n++;
	XtSetArg( args[n], XtNeditType, help->mode );	n++;
	XtSetArg( args[n], XtNlength, help->bufSize );	n++;
	XtSetArg( args[n], XtNwidth, 500 );	n++;
	XtSetArg( args[n], XtNheight, 200 );	n++;
	text = XtCreateManagedWidget( "text", asciiTextWidgetClass, frame, args, n );
	help->text = text;

	n = 0;
	XtSetArg( args[n], XtNstring, helpText );	n++;
	XtSetArg( args[n], XtNlength, help->bufSize );	n++;
	XtSetArg( args[n], XtNeditType, help->mode );	n++;
	XawTextSetSource( help->text,
			XawStringSourceCreate( help->text, args, n ), (XawTextPosition)0 );

	/* create controls */
	n = 0;
	XtSetArg( args[n], XtNfromVert, text );		n++;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	controls = XtCreateManagedWidget( "helpControls", boxWidgetClass, frame, args, n );

	/* create button */
	n = 0;
	XtSetArg( args[n], XtNlabel, "done" );	n++;
	done = XtCreateManagedWidget( "doneButton", commandWidgetClass, controls, args, n );
	XtAddCallback( done, XtNcallback, ExitHelpWin, (caddr_t)help );

	XtManageChild( frame );
	XtRealizeWidget( help->shell );

	return help;
}

void	StartHelpWin( help )
HelpWin	help;
{
	XtPopup( help->shell, XtGrabNone );
	XtSetSensitive( help->button, False );		/* disable push help button */
}
#endif

/*---------------------------------------------------------------------------------------------*/
/* Callbacks */

void	LinkUpCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int	n;
	Arg	arg[3];
	char	LinkName[100];

	if ( Connect == TRUE )
	{
		Error( "Connected, can not change link" );
	}
	else
	{
		if ( ++LinkId >= MAXLINKS )
			LinkId = 0;
		sprintf( LinkName, LINKBUTTONLABEL, LinkId );
		n = 0;
		XtSetArg( arg[n], XtNlabel, LinkName );		n++;
		XtSetValues( w, arg, n );
	}
}

void	LinkDownCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int     n;
	Arg     arg[3];
	char	LinkName[100];

	if ( Connect == TRUE )
	{
		Error( "Connected, can not change link" );
        }
        else
        {
		if ( --LinkId < 0 )
			LinkId = MAXLINKS -1;
                sprintf( LinkName, LINKBUTTONLABEL, LinkId );
		n = 0;
		XtSetArg( arg[n], XtNlabel, LinkName );		n++;
		XtSetValues( w, arg, n );
	}
}

#define	CONNECTERRMASK	"\n"\
		"button: connect to tranputer\n"\
		"\n"\
		"error message returned from LinkAlloc:\n"\
		"\n"\
		"%s\n"

void	ConnectCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int	n;
	Arg	arg[10];

	if ( Connect == FALSE )
	{
		char	ErrText[100];
		int err = LinkAlloc( LinkId , ErrText, TRUE );

		if (err == LinkId )
		{
			n = 0;
			XtSetArg( arg[n], XtNlabel, DISCONNECTBUTTONLABEL );	n++;
			XtSetValues( connectcommand, arg, n );

			Connect = TRUE;
		}
		else
		{
		static	char	text[2000];

			sprintf( text, CONNECTERRMASK, ErrText );
			Error( text );
		}
	}
	else
	{
		n = 0;
		XtSetArg( arg[n], XtNlabel, CONNECTBUTTONLABEL );	n++;
		XtSetValues( w, arg, n );

		LinkFree( LinkId, TRUE );
		Connect = FALSE;
	}

	n = 0;
	XtSetArg( arg[n], XtNsensitive, !Connect ); n++;
	XtSetValues( linkcommand, arg, n );
	XtSetValues( exitcommand, arg, n );
	n = 0;
	XtSetArg( arg[n], XtNsensitive, Connect ); n++;
	XtSetValues( resetcommand, arg, n );
	XtSetValues( loadcommand, arg, n );
	XtSetValues( startcommand, arg, n );
}

void	ResetCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	if ( Connect == TRUE )
	{
		int err = ResetLink( LinkId );
		if (err != 1)
		{
		static	char	text[100];
			sprintf( text, "can not reset link, error %d\n", err );
			Error( text );
		}
	}
	else
	{
		Error( "can not reset, not connected\n" );
	}
}

#define	DEBUGERRMASK1	"\n"\
			"Can't debug transputer.\n"\
			"Tranputer not allocated.\n"

#define	DEBUGERRMASK2	"\n"\
			"Can't debug transputer.\n"\
			"Unable to load debug program.\n"

#define	DEBUGERRMASK3	"\n"\
			"Can't debug transputer.\n"\
			"Connection to transputer debugger lost.\n"

#define	DEBUGMASK	"\n"\
			"Debugging informations:\n"\
			"\n"\
			"Transputer %d link %d connected with VME-Bus.\n"\
			"Processor speed: %4.1f MHz\n"\
			"Processor type:  %s\n"\
			"Memory:          $%x bytes\n"\
			"Memory speed:    %d\n"\
			"\n"\
			"---------------------------------------------------------\n"\
			"\n"\
			"Debugging is not complete implemented yet.\n"\
			"\n"\
			"You must debug the root transputer by yourself.\n"\
			"Sorry for this, but it will work automatically later.\n"\
			"\n"\
			"1990 October 10\n"\
			"\n"

void	DebugCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	if ( Connect == TRUE ) {
	static	char	debugInfo[1000];

		int	err = LoadProgram( LinkId, 50, DebugName );
		if ( !err ) {
			int	linkToVMEId;
			int	procSpeed;
			int	procType;
			char	typeStr[100];
			int	memStart, memTop;
			int	xMemSpeed;

			err = DebugServer( &linkToVMEId, &procSpeed, typeStr, &memStart, &memTop, &xMemSpeed );

			if ( err ) {
				Error( DEBUGERRMASK3 );
			} else {
				sprintf( debugInfo, DEBUGMASK, LinkId, linkToVMEId, (float)procSpeed / (float)4.0,
						typeStr, memTop - memStart, xMemSpeed );
				Debug( debugInfo );
			}
		} else {
			Error( DEBUGERRMASK2 );
		}
	} else {
		Error( DEBUGERRMASK1 );
	}
}

static	char	*helpText =	"\n"\
				"The full text of help is not available, because the help file\n"\
				"couldn't be opened.\n"\
				"\n"\
				"xserver is a simple interactive transputer server program.\n"\
				"It is build on the X-Toolkit and the Athena Widgets.\n"\
				"\n"\
				"You can start the program as: xserver [ .. ]\n"\
				"\n"\
				"CREDITS:\n"\
				"	Version 1.1 beta\n"\
				"	Author: Ralf Diekmann, Jens C.H. Simon\n"\
				"\n";

void	HelpCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
static	EditorWin	help = NULL;
	char	*iconName = "xserver: help";
	Arg	args[3];
	int	n;

	if ( !help ) {
		help = CreateEditorWin( "helpWindow", "help window", 500, 200, XawtextRead );
		ChangeTextSource( help, helpText );
		help->button = w;
	}
	n = 0;
	XtSetArg( args[n], XtNiconName, iconName );
	XtSetValues( help->shell, args, n );
	StartEditorWin( help );
}

void	ProgoCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int	n;
	Arg	arg[3];

	n = 0;
	XtSetArg( arg[n], XtNsensitive, FALSE ); n++;
	XtSetValues( progocommand, arg, n );

	XtPopup( popoccamfile, XtGrabNone );
}

void	ProgcCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	int	n;
	Arg	arg[3];

	n = 0;
	XtSetArg( arg[n], XtNsensitive, FALSE ); n++;
	XtSetValues( progccommand, arg, n );

	XtPopup( popcfile, XtGrabNone );
}

void	LoadCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	if (Connect == TRUE )
	{
		int err = LoadProgram( LinkId, 50, ProgName );
		if (err != 0)
		{
		static	char	text[100];
			sprintf(text, "Load error %d\n", err);
			Error( text );
		}
	}
	else
	{
		Error( "not connected\n" );
	}
}

void	StartCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	if (Connect == TRUE )
	{
	static	char    ErrMsg[100], Kommando[100];
		int	n;
		Arg	arg[3];
		int	err;

		C_running = TRUE;
		XtSetSensitive( connectcommand, !C_running );

		LinkFree( LinkId, TRUE );
		sprintf( Kommando, "%s %d&", CName, LinkId );
		system( Kommando );

		n = 0;
		XtSetArg( arg[n], XtNlabel, CONNECTBUTTONLABEL );	n++;
		XtSetValues( connectcommand, arg, n );

		Connect = FALSE;
		C_running = FALSE;
		XtSetSensitive( connectcommand, !C_running );
		n = 0;
		XtSetArg( arg[n], XtNsensitive, !Connect ); n++;
		XtSetValues( linkcommand, arg, n );
		XtSetValues( exitcommand, arg, n );
		n = 0;
		XtSetArg( arg[n], XtNsensitive, Connect ); n++;
		XtSetValues( resetcommand, arg, n );
		XtSetValues( loadcommand, arg, n );
		XtSetValues( startcommand, arg, n );
	}
	else
	{
		Error( "not connected\n" );
	}
}

void	ExitCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	if ( Connect == TRUE )
	{
		Error( "connect\n" );
	}
	else
	{
		printf("Exit XServer !\n");
		exit();
	}
}

Widget	ButtonBox1( parentbox )
Widget	parentbox;
{
	Arg	arg[10];
	int	n;
	Widget	buttonbox,
		box,
		debugcommand;		/* Link Debugging */
	char	LinkName[100];

	n = 0;
	XtSetArg( arg[n], XtNborderWidth, 0 );	n++;
	XtSetArg( arg[n], XtNx, 5 );		n++;
	XtSetArg( arg[n], XtNy, 5 );		n++;
	XtSetArg( arg[n], XtNwidth, 600 );	n++;
	XtSetArg( arg[n], XtNheight, 20 );	n++;
	box = XtCreateWidget( "box", boxWidgetClass, parentbox, arg, n);

	sprintf(LinkName, LINKBUTTONLABEL, LinkId );
	n = 0;
	XtSetArg( arg[n], XtNsensitive, !Connect );	n++;
	linkcommand = XtCreateManagedWidget( LinkName, commandWidgetClass, box, arg, n );
	XtOverrideTranslations(linkcommand, XtParseTranslationTable(linkTranslations));

	n = 0;
	XtSetArg( arg[n], XtNsensitive, !C_running );	n++;
	connectcommand = XtCreateManagedWidget( CONNECTBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( connectcommand, XtNcallback, ConnectCallback, NULL );

	n = 0;
	XtSetArg( arg[n], XtNsensitive, Connect );	n++;
	resetcommand = XtCreateManagedWidget( RESETBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( resetcommand, XtNcallback, ResetCallback, NULL );

	n = 0;
	debugcommand = XtCreateManagedWidget( DEBUGBUTTONLABEL, commandWidgetClass, box, arg, n );
	XtAddCallback( debugcommand, XtNcallback, DebugCallback, NULL );

	return box;
}

Widget	ButtonBox2( parentbox )
Widget	parentbox;
{
	Arg	arg[10];
	int	n;
	Widget	box,
		helpcommand;		/* Help window */

	n = 0;
	XtSetArg( arg[n], XtNborderWidth, 0 );	n++;
	XtSetArg( arg[n], XtNx, 5 );		n++;
	XtSetArg( arg[n], XtNy, 30 );		n++;
	XtSetArg( arg[n], XtNwidth, 600 );	n++;
	XtSetArg( arg[n], XtNheight, 20 );	n++;
	box = XtCreateWidget( "box", boxWidgetClass, parentbox, arg, n);
	
	n = 0;
	progocommand = XtCreateManagedWidget( PROGOBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( progocommand, XtNcallback, ProgoCallback, NULL );

	n = 0;
	XtSetArg( arg[n], XtNsensitive, Connect );	n++;
	loadcommand = XtCreateManagedWidget( LADEBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( loadcommand, XtNcallback, LoadCallback, NULL );

	n = 0;
	progccommand = XtCreateManagedWidget( PROGCBUTTONLABEL, commandWidgetClass, box, arg, n );
	XtAddCallback( progccommand, XtNcallback, ProgcCallback, NULL );

	n = 0;
	XtSetArg( arg[n], XtNsensitive, Connect );	n++;
	startcommand = XtCreateManagedWidget( STARTBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( startcommand, XtNcallback, StartCallback, NULL );

	n = 0;
	helpcommand = XtCreateManagedWidget( HELPBUTTONLABEL, commandWidgetClass, box, arg, n );
	XtAddCallback( helpcommand, XtNcallback, HelpCallback, NULL );

	n = 0;
	XtSetArg( arg[n], XtNsensitive, !Connect );	n++;
	exitcommand = XtCreateManagedWidget( ENDEBUTTONLABEL, commandWidgetClass, box, arg, n );
        XtAddCallback( exitcommand, XtNcallback, ExitCallback, NULL );

	return box;
}

void	usage( name )
char	*name;
{
	fprintf( stderr, "usage: %s [-o occam.bin] [-c chost] [-u debug.bin]\n", name );

	exit (0);
}

void	arguments( argc, argv )
int	argc;
char	**argv;
{
	char	*AppName;		/* Name der Applikation */
	char	**ap;

	AppName = argv[0];
	ap = argv;
	while ( *++ap ) {
		if (!strncmp( *ap, "-o", 2 ) ) {
			if ( *++ap)
				strcpy( ProgName, *ap );
			else
				usage( AppName );
		} else {
			if (!strncmp( *ap, "-c", 2 ) ) {
				if ( *++ap )
					strcpy(  CName, *ap );
				else
					usage( AppName );
			} else {
				if (!strncmp( *ap, "-f", 2 ) ) {
					if ( *++ap ) {
						strcpy(  Farbe, *ap );
					} else
						usage( AppName );
				} else {
					if (!strncmp( *ap, "-u", 2 ) ) {
						if ( *++ap )
							strcpy(  DebugName, *ap );
						else
							usage( AppName );
					}
				}
			}
		}
	}
}

/*-----------------------------------------------------------------------*/

int main( argc,  argv )
int	argc;
char	*argv[];
{
	Pixmap	icon_pixmap = None;
	Arg	arg[10];
	int	n;
	Widget	box,
		buttonbox1,		/* Box 1 fuer die Command Buttons */
		buttonbox2;		/* Box 2 fuer die Command Buttons */

	toplevel = XtInitialize( "main", "XServer", NULL, 0, &argc, argv );

	arguments( argc, argv );

	n = 0;
	XtSetArg( arg[n], XtNiconPixmap, &icon_pixmap ); n++;
	XtGetValues( toplevel, arg, n );
	if ( icon_pixmap == None )
	{
		n = 0;
		XtSetArg( arg[n], XtNiconPixmap,
				XCreateBitmapFromData( XtDisplay(toplevel),
						XtScreen(toplevel)->root,
						xserver_bits,
						xserver_width,
						xserver_height ) );
		n++;
		XtSetValues( toplevel, arg, n );
	}

	XtAddActions(actionTable, actionTable_num );

	n = 0;
	XtSetArg( arg[n], XtNwidth, 610 );	n++;
	XtSetArg( arg[n], XtNheight, 70 );	n++;
	box = XtCreateManagedWidget( "box", formWidgetClass, toplevel, arg, n );

	buttonbox1	= ButtonBox1( box );
	buttonbox2	= ButtonBox2( box );

	PopOccamfile( toplevel );
	PopCfile( toplevel );

	XtRealizeWidget( toplevel );
	XtMapWidget( buttonbox1 );
	XtMapWidget( buttonbox2 );

	XtMainLoop();
}
