#include <stdio.h>
#include <time.h>
#include "xserver_debug.h"
#include "../../c_occam.h"

/*
#define	TRACE
*/

extern	int	LinkId;		/* defined in linkio.c */
	int	comm_Err = 0;
	int	optInd = 0;
	int	gArgc = 0;
	char	***argv_p;

#define PutHeader(command) byte_to_link_t(FC_PH1);byte_to_link_t(FC_PH2);byte_to_link_t(command);byte_to_link_t(FC_PH4)

int	Trace = TRUE;

void	ProgramExit(flag)
int flag;
{
#ifdef	TRACE
	if ( comm_Err )
		printf ("Communication failure, %d bytes skipped", comm_Err);
#endif
}
/*-----------------------------------------------------------------------------------------------------*/

unsigned int GetCommand()
{
	int	Uncertain = TRUE ;
	byte	r, h ;

	h = byte_from_link() ;

	while ( Uncertain )
	{
		while ( h != FC_PH1 )
		{
#ifdef	TRACE
			if ( Trace )
				printf(" PH1=%x ",h);
#endif
			h = byte_from_link() ;
			comm_Err++ ;
		}

		h = byte_from_link() ;
	try2:
		if (h != FC_PH2 )
		{
#ifdef	TRACE
			if ( Trace )
				printf(" PH2= %x ") ;
#endif
			comm_Err++ ;
		}
		else
		{
			r = byte_from_link() ;

			if ( ((Uncertain = ((h = byte_from_link()) != FC_PH4))==TRUE ) )
				if (r == FC_PH1)
					goto try2 ;
				else
				{
#ifdef	TRACE
					if ( Trace )
						printf(" PH4= %x ");
#endif
					comm_Err++ ;
				}
		}
	}

	return r & 0xff ;
}

/*-----------------------------------------------------------------------*/
/*---------------------------*/
void	Serve_Getarg(command) 
unsigned int	command; 
{
	int		i;
	unsigned int	len = 0 ;
	Tword		Cid ;
	char		cmdline[256] ;

	Cid = word_from_link() ;
	for (i=optInd; i<gArgc; i++) {
		char *NextArg = (*argv_p)[i] ;
		strcpy ( &cmdline[len] ,NextArg ) ;
		len += strlen( NextArg ) ;
		cmdline[len++] = ' ' ;
	}

	if (len == 0) len = 1 ;
	cmdline[len-1] = 0 ;
#ifdef	TRACE
	if (Trace)
		printf("\nSending commandline:<%s> ; ",cmdline);
#endif
	PutHeader(command);
	word_to_link_t(Cid);
	word_to_link_t(len);
	putbuf ( cmdline, len ) ;
}

/*-----------------------------------------------------------------------*/
/*---------------------------*/
void	Serve_Exit( command )
int	command;
{
	Tword	Cid, ExitValue;

	Cid = word_from_link();
	ExitValue = word_from_link();
#ifdef	TRACE
	if ( Trace )
		printf( "\nExit on request of program, exitcode %ld ; \n", ExitValue );
#endif
	PutHeader( command );
	word_to_link_t( Cid );
	ProgramExit( ExitValue );
}

/*-----------------------------------------------------------------------*/
/*---------------------------*/
void	Serve_OpenStd( command )
unsigned int	command;
{
	Tword	Cid, xFidIn, xFidOut, xFidErr;

	Cid = word_from_link();

	xFidIn = word_from_link();
	xFidOut = word_from_link();
	xFidErr = word_from_link();

	PutHeader( command );
	word_to_link( Cid );
	word_to_link( 0 );
	word_to_link( 0 );
	word_to_link( 0 );
}
/*-----------------------------------------------------------------------*/
/*---------------------------*/
void	Serve_Getenv( command )
unsigned int	command;
{
	Tword	cid;
	char	*var, *env;

	cid = word_from_link();
	var = (char*)getstring();
	env = (char*)getenv( var );
	if ( env == NULL )
		env = "";
#ifdef	TRACE
	if ( Trace )
		printf( "\ngetenv(\"%s\") = %s ; ", var, env );	
#endif
	PutHeader( command );
	word_to_link( cid );
	putstring( env );
	free( var );
}
/*-----------------------------------------------------------------------*/
/*---------------------------*/
void	Serve_Time( command )
unsigned int	command;
{
	int	time;
	Tword	cid;

	cid = word_from_link();
#ifdef	TRACE
	if ( Trace )
		printf( "\ntime ; " );
#endif
	PutHeader( command );
	word_to_link( cid );
	word_to_link( time );
}

void	Server( linkToVMEId, procSpeed, typeStr, memStart, memTop, xMemSpeed )
int	*linkToVMEId;
int	*procSpeed;
char	*typeStr;
int	*memStart, *memTop;
int	*xMemSpeed;
{
	int	procType;

	*linkToVMEId = word_from_link();

	*procSpeed = word_from_link();

	procType = word_from_link();
	switch ( procType ) {
		case T414:
			strcpy( typeStr, "T414" );
			break;
		case T424:
			strcpy( typeStr, "T424" );
			break;
		case T800:
			strcpy( typeStr, "T800" );
			break;
		case T810:
			strcpy( typeStr, "T810" );
			break;
		default:
			strcpy( typeStr, "????" );
			break;
	}

	*memStart = word_from_link();
	*memTop = word_from_link();
	*xMemSpeed = word_from_link();
}

int	DebugServer( linkToVMEId, procSpeed, typeStr, memStart, memTop, xMemSpeed )
int	*linkToVMEId;
int	*procSpeed;
char	*typeStr;
int	*memStart, *memTop;
int	*xMemSpeed;
{
	int	running = TRUE;

	while ( running ) {
		byte	cmd;

		cmd = GetCommand();
		switch ( cmd ) {
			case 0x51:
					Serve_Time( cmd );
					Server( linkToVMEId, procSpeed, typeStr, memStart, memTop, xMemSpeed );
					break;
			case 0x52:
					Serve_Getenv( cmd );
					break;
			case 0x62:
					Serve_Getarg( cmd );
					break;
			case 0x64:
					Serve_OpenStd( cmd );
					break;
			case 0x61:
					Serve_Exit( cmd );
					return 0;
			default:
#ifdef	TRACE
				fprintf( stderr, "unknown command received: %x\n", cmd );
#endif
				return 1;
		}
	}
}

