/*************************************************************************

		xtsp.c, v 1.20  90/2/9  8:57:43   author CH

**************************************************************************/

#include <stdio.h> 
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/AsciiText.h>
#include "../widgets/Tsp.h"
#include "../widgets/Diagram.h"
#include "../widgets/Timer.h"
#include "xtsp.bit"
#include "xtsp.h"

extern	double	atof();
extern	void	exit();

/*-------------------------------------------*/
/* Variablen */

#define	GNAMELEN	100
#define	STRLEN		20

int	LinkId;
char	GraphName[GNAMELEN] = "instanzen/tsp442.instanz";
char	TempStr[STRLEN] = "20";
float	Temp = 20.0;
char	LaengeStr[STRLEN] = "113";
int	Laenge = 113;
char	TiefeStr[STRLEN] = "20000";
int	Tiefe = 20000;
char	AlphaStr[STRLEN] = "0.96";
float	Alpha = 0.96;
char	RandomStr[STRLEN] = "1";
int	Random = 1;

int	debugflag = FALSE;
/*-------------------------------------------*/
/* Widgets */

Widget	toplevel;

Widget	zielwertdiagram;
Widget	tempdiagram;
Widget	acceptdiagram;

Widget	timer;

/*-------------------------------------------*/

static XrmOptionDescRec options[] = {
{"-rv",			"*tsp.reverseVideo",	XrmoptionSepArg,	 NULL},
{"-reverseVideo",	"*tsp.reverseVideo",	XrmoptionSepArg,	 NULL},
};

/*******************************************************************************************************
**
**  Popup-Windows
**
*********************/

/*
**  Error popup
*/

#define textBufferSize	10000

typedef	struct {
	Widget	shell;		/* popup shell widget */
	Widget	title;		/* error title widget */
	Widget	text;		/* error text widget */
	char	*buffer;	/* error text buffer */
	int	bufSize;	/* size of error text */
	int	mode;		/* error text widget mode */
} ErrorWinRec, *ErrorWin;

void	ExitErrorWin( w, client_data, call_data )
Widget	w;
caddr_t	client_data;
caddr_t	call_data;
{
	ErrorWin	error = (ErrorWin)client_data;

	XtPopdown( error->shell );
}

ErrorWin	CreateErrorWin( name, mode )
char*	name;
int	mode;
{
	ErrorWin	error = (ErrorWin)XtCalloc( 1, sizeof(ErrorWinRec) );
	Arg		args[7];
	int		n;
	Widget		frame, title, text, controls, done;

	n = 0;
	error->shell = XtCreatePopupShell( name, topLevelShellWidgetClass, toplevel, NULL, n );
	n = 0;
	frame = XtCreateWidget( "errorFrame", panedWidgetClass, error->shell, args, n );

	/* create title */
	n = 0;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	XtSetArg( args[n], XtNlabel, "error message" );	n++;
	title =  XtCreateManagedWidget( "errorTitle", labelWidgetClass, frame, args, n );
	error->title = title;

	error->buffer = XtCalloc( textBufferSize, sizeof(char) );
	error->bufSize = textBufferSize;
	error->mode = mode;

	/* create text */
	n = 0;
	XtSetArg( args[n], XtNstring, error->buffer );  n++;
	XtSetArg( args[n], XtNeditType, error->mode );  n++;
	XtSetArg( args[n], XtNlength, error->bufSize ); n++;
	XtSetArg( args[n], XtNwidth, 400 );     n++;
	XtSetArg( args[n], XtNheight, 200 );    n++;
	text = XtCreateManagedWidget( "text", asciiTextWidgetClass, frame, args, n );
	error->text = text;

	/* create controls */
	n = 0;
	XtSetArg( args[n], XtNfromVert, text );         n++;
	XtSetArg( args[n], XtNskipAdjust, True );       n++;
	controls = XtCreateManagedWidget( "errorControls", boxWidgetClass, frame, args, n );

	/* create button */
	n = 0;
	XtSetArg( args[n], XtNlabel, "done" );  n++;
	done = XtCreateManagedWidget( "doneButton", commandWidgetClass, controls, args, n );
	XtAddCallback( done, XtNcallback, ExitErrorWin, (caddr_t)error );

	XtManageChild( frame );
	XtRealizeWidget( error->shell );

	return error;
}

void	StartErrorWin( error )
ErrorWin	error;
{
	XtPopup( error->shell, XtGrabExclusive );
}

void	ChangeTextSource( error, str )
ErrorWin	error;
char		*str;
{
	Arg	args[3];
	int	n;
	Widget	old = XawTextGetSource( error->text );

	n = 0;
	XtSetArg( args[n], XtNstring, str );            n++;
	XtSetArg( args[n], XtNlength, error->bufSize ); n++;
	XtSetArg( args[n], XtNeditType, error->mode );  n++;
	XawTextSetSource( error->text,
			 XawStringSourceCreate( error->text, args, n ), (XawTextPosition)0 );
	XtDestroyWidget( old );
}

void	Error( str )
char	*str;			/* error message */
{
static	ErrorWin	error = NULL;
	char		*iconName = "xserver: error";
	Arg		args[1];
	int		n;

	if ( !error ) {
		error = CreateErrorWin( "errorWindow", XawtextRead );
	}

	ChangeTextSource( error, str );
	n = 0;
	XtSetArg( args[n], XtNiconName, iconName );     n++;
	XtSetValues( error->shell, args, n );

	StartErrorWin( error );
}

/*----------------------------------------------------------------------------------*/
/*
**  Parameter popup
*/

#define	DIALOGANZAHL	6

void	OkCallback( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	Widget	*dialog = (Widget*)client_data;

	strcpy( GraphName, XawDialogGetValueString( *dialog++ ) );
	strcpy( TempStr, XawDialogGetValueString( *dialog++ ) );
	strcpy( LaengeStr, XawDialogGetValueString( *dialog++ ) );
	strcpy( TiefeStr, XawDialogGetValueString( *dialog++ ) );
	strcpy( AlphaStr, XawDialogGetValueString( *dialog++ ) );
	strcpy( RandomStr, XawDialogGetValueString( *dialog++ ) );

	Temp = atof( TempStr );
	Laenge = atoi( LaengeStr );
	Tiefe = atoi( TiefeStr );
	Alpha = atof( AlphaStr );
	Random = atoi( RandomStr );
}

Widget	PopParameter( popup_w )
Widget	popup_w;				/* das Widget, welches das Popup ausfuehrte */
{
	static	Widget	pop;			/* das Widget der Popupshell */
	static	XtPopdownIDRec	idrec;		/* Beinhaltet die Widget-Id's von pop und popup_w */
	static	Widget	dialog[DIALOGANZAHL];	/* Die Dialog-Widgets */

	int	n;
	Arg	args[5];
	Widget	frame, dialogs, controls, ok, cancel;

	/* create the top level form widget */

	n = 0;
	pop = XtCreatePopupShell( "parameter", topLevelShellWidgetClass, toplevel, args, n );

	n = 0;
	frame = XtCreateWidget( "parameterFrame", panedWidgetClass, pop, args, n );

	/* create dialogs */

	n = 0;
	XtSetArg( args[n], XtNwidth, (XtArgVal)500 );	n++;
	XtSetArg( args[n], XtNheight, (XtArgVal)300 );	n++;
	dialogs = XtCreateManagedWidget( "dialog", boxWidgetClass, frame, args, n );

	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Graphdatei:                         " );	n++;
	XtSetArg( args[n], XtNvalue, GraphName );		n++;
	XtSetArg( args[n], XtNresizable, True );		n++;
	dialog[0] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );

	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Starttemperatur:");	n++;
	XtSetArg( args[n], XtNvalue, TempStr );				n++;
	XtSetArg( args[n], XtNresizable, True );			n++;
	dialog[1] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );

	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Markoff-Laenge:");	n++;
	XtSetArg( args[n], XtNvalue, LaengeStr );			n++;
	XtSetArg( args[n], XtNresizable, True );			n++;
	dialog[2] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );
		
	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Markoff-Tiefe:" );	n++;
	XtSetArg( args[n], XtNvalue, TiefeStr );			n++;
	XtSetArg( args[n], XtNresizable, True );			n++;
	dialog[3] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );

	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Alpha:" );		n++;
	XtSetArg( args[n], XtNvalue, AlphaStr );			n++;
	XtSetArg( args[n], XtNresizable, True );			n++;
	dialog[4] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );

	n = 0;
	XtSetArg( args[n], XtNlabel, (XtArgVal)"Startwert Random:" );	n++;
	XtSetArg( args[n], XtNvalue, RandomStr );			n++;
	XtSetArg( args[n], XtNresizable, True );			n++;
	dialog[5] = XtCreateManagedWidget( "dialog", dialogWidgetClass, dialogs, args, n );

	idrec.shell_widget = pop;
	idrec.enable_widget = popup_w;

	/* create controls */

	n = 0;
	XtSetArg( args[n], XtNfromVert, dialogs );	n++;
	XtSetArg( args[n], XtNskipAdjust, True );	n++;
	controls = XtCreateManagedWidget( "parameterControls", boxWidgetClass, frame, args, n );

	n = 0;
	ok = XtCreateManagedWidget( "OK!", commandWidgetClass, controls, args, n);
	XtAddCallback( ok, XtNcallback, OkCallback, (caddr_t)dialog );
	XtAddCallback( ok, XtNcallback, XtCallbackPopdown, &idrec );

	n = 0;
	cancel = XtCreateManagedWidget( "CANCEL!", commandWidgetClass, controls, args, n);
	XtAddCallback( cancel, XtNcallback, XtCallbackPopdown, &idrec );

	XtManageChild( frame );

	return pop;		/* gebe Widget-Id der Popupshell zurueck */
}

Widget	ZielwertPopup( toplevel )
Widget	toplevel;
{
	static	Widget	zielwertpop;
		
	int	n;
	Arg	arg[5];

	n = 0;
	zielwertpop = XtCreatePopupShell( "Zielwert", topLevelShellWidgetClass, toplevel, arg, n );

	n = 0;
	XtSetArg( arg[n], XtNlabel, "Zielwert:");	n++;
	zielwertdiagram = XtCreateManagedWidget( "diagram", diagramWidgetClass, zielwertpop, arg, n );

	return zielwertpop;
}

Widget	TemperaturPopup( toplevel )
Widget	toplevel;
{
	static	Widget	temperaturpop;
	int	n;
	Arg	arg[5];

	n = 0;
	temperaturpop =  XtCreatePopupShell( "Temperatur", topLevelShellWidgetClass, toplevel, arg, n );

	n = 0;
	XtSetArg( arg[n], XtNlabel, "Temperatur:");	n++;
	tempdiagram = XtCreateManagedWidget( "diagram", diagramWidgetClass, temperaturpop, arg, n );

	return temperaturpop;
}

Widget	AkzeptPopup( toplevel )
Widget	toplevel;
{
	static	Widget	acceptpop;
	int	n;
	Arg	arg[5];

	n = 0;
	acceptpop = XtCreatePopupShell( "Akzeptierungen", topLevelShellWidgetClass, toplevel, arg, n );

	n = 0;
	XtSetArg( arg[n], XtNlabel, "Akzeptierungen:" );	n++;
	acceptdiagram = XtCreateManagedWidget( "diagram", diagramWidgetClass, acceptpop, arg, n );

	return	acceptpop;
}

/*------------------------------------------------------------------------------------------------------------*/

void usage( name )
char	*name;
{
	fprintf(stderr,
	"usage: %s	linkname [-fn {font}] [-update {seconds}] [-scale {integer}] [-rv]\n", name );
	fprintf(stderr,
	"		[-geometry [{width}][x{height}][{+-}{xoff}[{+-}{yoff}]]] [-display [{host}]:[{vs}]]\n" );
	fprintf(stderr,
	"		[-fg {color}] [-bg {color}] [-bd {color}] [-bw {pixels}]\n");
	exit(1);
}

void	SetzeLink( link_name )
char	*link_name;
{
	int	err;
	char	ErrMsg[100];

	LinkId = atoi( link_name );

	err = LinkAlloc( LinkId, ErrMsg, TRUE );
	if (err != LinkId ) {
		fprintf( stderr, "%s\n", ErrMsg );
		exit(1);
	}
}

void	ExitApplication( return_code )
int	return_code;
{
	LinkFree( LinkId, TRUE );
	exit( return_code );
}

/*------------------------------------------------------------------------------------*/
int	n;
int	mode;				/* Kodierung der Instanzart. */
float	optimumKosten;			/* Die global besten Kosten der Instanz */
float	*xkoord = NULL;
float	*ykoord = NULL;

void	EndeLeseInstanz()
{
	free( xkoord ); free( ykoord );
}

int	LeseInstanz( dateiName )
char		*dateiName;
/*
	return: 0 => kein Felher aufgetreten
*/
{
	FILE	*f;
	int	i;

	if ( (f = fopen( dateiName, "r" )) == NULL ) {
		Error( "Fehler: Datei der Instanz nicht gefunden.\n" );
		return -1;
	}
	fscanf( f, "%d", &n );
	fscanf( f, "%f", &optimumKosten );
	fscanf( f, "%d", &mode );
	switch ( mode ) {
		case 1:
			break;
		case 10:
			break;
		default:
			Error( "Fehler: Falsche Instanzart\n" );
			return -1;
			break;
	}
	xkoord = (float*)malloc( n * sizeof( float ) );
	ykoord = (float*)malloc( n * sizeof( float ) );
	for ( i=0; i<n; i++ ) {
		fscanf( f, "%f", &xkoord[i] );
		fscanf( f, "%f", &ykoord[i] );
	}
	fclose( f );
	return 0;
}

int	SendeInstanz()
{
	int	i;

	if ( SendProt( LinkId, 50, PARAMPROTOCOL ) ) {
		Error( "Fehler: Parameter werden vom OCCAM Programm nicht empfangen\n" );
		return -1;
	}
	if ( SendReal( LinkId, 50, &Temp ) ) {
		return -1;
	}
	if ( SendInt( LinkId, 50, &Laenge ) ) {
		return -1;
	}
	if ( SendInt( LinkId, 50, &Tiefe ) ) {
		return -1;
	}
	if ( SendReal( LinkId, 50, &Alpha ) ) {
		return -1;
	}
	if ( SendInt( LinkId, 50, &Random ) ) {
		return -1;
	}
if ( debugflag ) printf("OK!!\n");
if ( debugflag ) printf("Sende die Instanz ...");

	if ( SendProt( LinkId, 50, TOWNPROTOCOL ) ) {
		Error( "Fehler: OCCAM Programm empfaengt die Instanz nicht\n");
		return -1;
	}
	if ( SendInt( LinkId, 50, &n ) != 0 ) {
		return -1;
	}
	if ( SendInt( LinkId, 50, &mode ) != 0 ) {
		return -1;
	}
	if ( SendReal( LinkId, 50, &optimumKosten ) != 0 ) {
		return -1;
	}
	for (i=0; i < n; i++ )
		if ( SendReal( LinkId, 50, &xkoord[i] ) != 0 ) {
			return -1;
		}
	for (i=0; i < n; i++ )
		if ( SendReal( LinkId, 50, &ykoord[i] ) != 0 ) {
			return -1;
		}
if ( debugflag ) printf("OK!!\n");
	return 0;
}

void	load( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	TspWidget	tsp = (TspWidget)client_data;

	if ( LeseInstanz( GraphName ) != 0 ) {
		EndeLeseInstanz();
		return;
	}
	XtSetTownPositions( tsp , n, xkoord , ykoord );
if ( debugflag ) printf("Sende die Parameter ...  ");
	if ( SendeInstanz() != 0 ) {
		EndeLeseInstanz();
		return;
	}
	EndeLeseInstanz();
	XtClean( tsp );
	XtCalculatePos( tsp );
	XtDrawTowns( tsp );
if ( debugflag ) printf("start calculation\n");
}

void	debug( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	CommandWidget	debugc = (CommandWidget)client_data;
	int	n;
	Arg	arg[5];

	debugflag = !debugflag;
	n = 0;
	if ( debugflag )
		XtSetArg( arg[n], XtNlabel, DEBUGON );
	else
		XtSetArg( arg[n], XtNlabel, DEBUGOFF );
	n++;
	XtSetValues( debugc, arg, n );
}

void	quit( w, client_data, call_data )
Widget	w;
caddr_t	client_data, call_data;
{
	ExitApplication( 0 );
}

/*---------------------------------------------------------------------*/

int	EmpfangeTour( tsp )
TspWidget	tsp;
{
	int	tour[800];
	int	n, i;

if ( debugflag ) printf( "receive tour " );
	ReceiveInt( LinkId, 50, &n );

if ( debugflag ) printf("n: %d .... ", n );
	for (i=0; i<n; i++)
		ReceiveInt( LinkId, 50, &tour[i] );
	XtDraw( tsp, tour );

if ( debugflag ) printf( " Ok!\n" );
	return 0;
}

/*---------------------------------------------------------------------*/

int	EmpfangeTourlen()
{
	float	Tour_Laenge;

	ReceiveReal( LinkId, 50, &Tour_Laenge );
	XtSetDiagramValue( zielwertdiagram, (double)Tour_Laenge );
if ( debugflag ) printf("Tour hat die Laenge: %f\n", Tour_Laenge );
}

/*---------------------------------------------------------------------*/

int	EmpfangeTemperatur()
{
	float	Temperatur;

	ReceiveReal( LinkId, 50, &Temperatur );
	XtSetDiagramValue( tempdiagram, (double)Temperatur );
if ( debugflag ) printf("Temperatur: %f\n", Temperatur );
}

/*---------------------------------------------------------------------*/

int	EmpfangeAkzeptierungen()
{
	int	accept;

	ReceiveInt( LinkId, 50, &accept );
	XtSetDiagramValue( acceptdiagram, (double)accept );
if ( debugflag ) printf("Akzeptierungen: %d\n", accept );
}

/*---------------------------------------------------------------------*/

void	EmpfangeVersion()
{
	int	version;

	ReceiveInt( LinkId, 50, &version );
	if ( version != 1 )
		Error( "Fehler: OCCAM Programm sendet FALSCHE Versionsnummer\n" );
if ( debugflag ) printf("Versionsnummer %d:\n", version );
}

/*---------------------------------------------------------------------*/

void	ReadProtocol( tsp, LinkId )
TspWidget	tsp;
int	LinkId;
{
	char	prot;

	ReceiveProt( LinkId, 50, &prot );
if ( debugflag ) printf("Protokoll: %d \n", prot );
	switch ( prot ) {
		case TOURPROTOCOL:
			EmpfangeTour( tsp );
			break;
		case STATISTICTOURLEN:
			EmpfangeTourlen();
			break;
		case STATISTICTEMP:
			EmpfangeTemperatur();
			break;
		case STATISTICACCEPT:
			EmpfangeAkzeptierungen();
			break;
		case NETSTARTED:
			XtSetStartTimer( (TimerWidget)timer );
			break;
		case NETTERMINATED:
			XtSetStopTimer( (TimerWidget)timer );
			break;
		case VERSION:
			EmpfangeVersion();
			break;
		default:
			Error( "error: protocol (%d)\n", prot );
	}
}

/*---------------------------------------------------------------------*/

int	OccamVersion()
{
	int	version = 1;


	if ( SendInt( LinkId, 50, &version ) != 0 ) {
		Error( "Fehler: OCCAM Programm empfaengt keine Versionsnummer\n");
		return -1;
	}
	if ( ReceiveInt( LinkId, 50, &version ) != 0 ) {
		Error( "Fehler: OCCAM Programm sendet keine Versionsnummer\n");
		return -1;
	}
	if ( version != 1 ) {
		Error( "Fehler: OCCAM Programm sendet FALSCHE Versionsnummer\n" );
		return -1;
	} else
		return 0;
}

/*---------------------------------------------------------------------*/

Boolean	polling( client_data )
caddr_t	client_data;
{
	if ( TestRead( LinkId ) ==  1 )
		ReadProtocol( (TspWidget)client_data, LinkId );

	return FALSE;		/* don't remove proc from work queue */
}

/*---------------------------------------------------------------------*/

void main(argc, argv)
    int argc;
    char **argv;
{
	Widget	frame, controls, tsp, paramspop, zielwertpop, temperaturpop, akzeptpop;
	Widget	paramsc, loadc, debugc, diagramc, quitc;
   	int	n;
	Arg	args[7];
	Pixmap	icon_pixmap = None;
	char	*application_name = argv[0];
	char	*link_name = argv[1];


	if (argc < 2) usage( application_name );
	SetzeLink( link_name );
	if ( OccamVersion() != 0 ) ExitApplication();

	toplevel = XtInitialize("main", "XTsp", options, XtNumber(options), &argc, argv);

	n = 0;
	XtSetArg (args[n], XtNiconPixmap, &icon_pixmap); n++;
	XtGetValues(toplevel, args, n);
	if (icon_pixmap == None) {
		n = 0;
		XtSetArg(args[n], XtNiconPixmap, 
			 XCreateBitmapFromData(XtDisplay(toplevel),
					       XtScreen(toplevel)->root,
					       xtsp_bits, xtsp_width, xtsp_height));
		n++;
		XtSetValues (toplevel, args, n);
	}

	n = 0;
	frame = XtCreateWidget( "xtspFrame", panedWidgetClass, toplevel, args, n );

	/* create tsp */

	n = 0;
	XtSetArg( args[n], XtNwidth, 500 );		n++;
	XtSetArg( args[n], XtNheight, 500 );		n++;
	tsp = XtCreateManagedWidget ("tsp", tspWidgetClass, frame, args, n);

	/* create controls */

	n = 0;
	XtSetArg (args[n], XtNfromVert, tsp );		n++;
	XtSetArg (args[n], XtNskipAdjust, True );	n++;
	controls = XtCreateManagedWidget ("xtspControls", boxWidgetClass, frame, args, n);

	n = 0;
	paramsc = XtCreateManagedWidget("read parameter", commandWidgetClass, controls, args ,n );
	paramspop = PopParameter( paramsc );
	XtAddCallback( paramsc, XtNcallback, XtCallbackNone, paramspop );

	n = 0;
	loadc = XtCreateManagedWidget( "load graph", commandWidgetClass, controls, args, n );
	XtAddCallback( loadc, XtNcallback, load, (caddr_t)tsp );

	n = 0;
	debugc = XtCreateManagedWidget( DEBUGON, commandWidgetClass, controls, args, n );
	XtAddCallback( debugc, XtNcallback, debug, (caddr_t)debugc );
	n = 0;
	if ( debugflag )
		XtSetArg( args[n], XtNlabel, DEBUGON );
	else
		XtSetArg( args[n], XtNlabel, DEBUGOFF );
	n++;
	XtSetValues( debugc, args, n );

	n = 0;
	diagramc = XtCreateManagedWidget( "diagrams", commandWidgetClass, controls, args, n );
	zielwertpop = ZielwertPopup( toplevel );
	temperaturpop = TemperaturPopup( toplevel );
	akzeptpop = AkzeptPopup( toplevel );
	XtAddCallback( diagramc, XtNcallback, XtCallbackNone, zielwertpop );
	XtAddCallback( diagramc, XtNcallback, XtCallbackNone, temperaturpop );
	XtAddCallback( diagramc, XtNcallback, XtCallbackNone, akzeptpop );

	n = 0;
	quitc = XtCreateManagedWidget( "quit", commandWidgetClass, controls, args, n );
	XtAddCallback( quitc, XtNcallback, quit, NULL );

	n = 0;
	XtSetArg( args[n], XtNupdate, 1 );	n++;
	timer = XtCreateManagedWidget( "timer", timerWidgetClass, controls, args, n );

	XtAddWorkProc( polling, (caddr_t)tsp );	/* Linkabfragen */

	XtManageChild( frame );

	XtRealizeWidget (toplevel);
	XtMainLoop();
}
